/*  XbW MetaFile eXchange (Interface to Applications): XBMFX  */

#ifdef ALREADY_DEFINED_MFX_mfi /*  #def'd ? */

#else 

#define ALREADY_DEFINED_MFX_mfi 1 

#ifndef ProgramName /* Extra Module */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define MFX_INIT 1
#include "xbmfx.h"
#include "simplemfx.h"

#endif /*ProgramName*/

#ifdef thestruct
#undef thestruct
#endif
#define thestruct mfi

int WriteMFXGroup_mfi(char*filename, char*dataset, char *mode){
  if (filename == NULL) { filename = "mfi.mfx"; } 
  if (dataset == NULL) { dataset = "mfi"; }
  if (mode == NULL) { mode = "w"; }
  if (XbWMFX_WriteSet(filename,dataset,mode)) {
    return(1);
    }
  { int i;
    for(i=0;i<111;i++){
      char sstr[100];
      sprintf(sstr,"itest[%d]",i);
      XbWMFX_PutInteger(&thestruct.itest[i],sstr);
      }
    }
  { int i,j;
    for(i=0;i<13;i++){
      for(j=0;j<4;j++){
        char sstr[100];
        sprintf(sstr,"ittest[%d][%d]",i,j);
        XbWMFX_PutInteger(&thestruct.ittest[i][j],sstr);
        }
      }
    }
  { int i;
    for(i=0;i<40;i++){
      char sstr[100];
      sprintf(sstr,"stest[%d]",i);
      XbWMFX_PutString(&thestruct.stest[i][0],sstr);
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        char sstr[100];
        sprintf(sstr,"sttest[%d][%d]",i,j);
        XbWMFX_PutString(&thestruct.sttest[i][j][0],sstr);
        }
      }
    }
  { int i;
    for(i=0;i<20;i++){
      char sstr[100];
      sprintf(sstr,"dtest[%d]",i);
      XbWMFX_PutDouble(&thestruct.dtest[i],sstr);
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        char sstr[100];
        sprintf(sstr,"dttest[%d][%d]",i,j);
        XbWMFX_PutDouble(&thestruct.dttest[i][j],sstr);
        }
      }
    }
  { int i;
    for(i=0;i<20;i++){
      char sstr[100];
      sprintf(sstr,"shtest[%d]",i);
      XbWMFX_PutShort(&thestruct.shtest[i],sstr);
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        char sstr[100];
        sprintf(sstr,"shttest[%d][%d]",i,j);
        XbWMFX_PutShort(&thestruct.shttest[i][j],sstr);
        }
      }
    }
  XbWMFX_WriteEnd();
  XbWMFX_CloseSet();
  return(0);
  }

int ReadMFXGroup_mfi(char*filename, char*dataset){
  if (filename == NULL) { filename = "mfi.mfx"; } 
  if (dataset == NULL) { dataset = "mfi"; }
  if (XbWMFX_ReadSet(filename,dataset)) {
    puts("ERR on opening MFX file; I will now try to append");
    ropenerr:;
    printf("a working MFX Group %s to the end of file %s...\n",dataset,filename);
    if (!WriteMFXGroup_mfi(filename,dataset,"a")){
      puts("...done. Exiting with error code.");
      printf("The end of file %s should now be readable. Please check its contents!\n",filename);
      printf("If %s did not exist until now, don't get crazy :)\n",filename);
      return(1);
      }
    else {
      puts("...did not work. Exiting with error code.");
      printf("I must now overwrite your file %s, sorry. Please check its contents!\n",filename);
      WriteMFXGroup_mfi(filename,dataset,"w");
      printf("If %s did not exist until now, don't get crazy :)\n",filename);
      return(1);
      }
    }
  { int i;
    for(i=0;i<111;i++){
      if(XbWMFX_GetInteger(&thestruct.itest[i])){ goto error; }
      }
    }
  { int i,j;
    for(i=0;i<13;i++){
      for(j=0;j<4;j++){
        if(XbWMFX_GetInteger(&thestruct.ittest[i][j])){
          goto error;
          }
        }
      }
    }
  { int i;
    for(i=0;i<40;i++){
      if(XbWMFX_GetString(&thestruct.stest[i][0])){goto error;}
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        if(XbWMFX_GetString(&thestruct.sttest[i][j][0])){goto error;}
        }
      }
    }
  { int i;
    for(i=0;i<20;i++){
      if(XbWMFX_GetDouble(&thestruct.dtest[i])){goto error;}
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        if(XbWMFX_GetDouble(&thestruct.dttest[i][j])){goto error;}
        }
      }
    }
  { int i;
    for(i=0;i<20;i++){
      if(XbWMFX_GetShort(&thestruct.shtest[i])){goto error;}
      }
    }
  { int i,j;
    for(i=0;i<4;i++){
      for(j=0;j<6;j++){
        if(XbWMFX_GetShort(&thestruct.shttest[i][j])){goto error;}
        }
      }
    }
  XbWMFX_CloseSet();
  return(0);
error:;
  printf("Error while reading MFX Group mfi\n");  XbWMFX_CloseSet();
  puts("I will now try to append");
  goto ropenerr;
  }



#undef thestruct

#endif /* ALREADY_DEFINED_MFX_... */
